#!/bin/sh

vif=$1

set_wpa_param() {
	sta_dis=$(uci -q get nhxsta.$1.disabled)
	sta_ssid=$(uci -q get nhxsta.$1.ssid)
	sta_bssid=$(uci -q get nhxsta.$1.bssid)
	sta_enc=$(uci -q get nhxsta.$1.encryption)
	sta_key=$(uci -q get nhxsta.$1.key)
	sta_pri=$(uci -q get nhxsta.$1.priority)

	if [ "$sta_dis" != "0" ]; then
		return
	fi
	echo "network={"
	echo "	scan_ssid=1"
	echo "	ssid=$sta_ssid"

	if [ -n "$sta_bssid" ]; then
		echo "	bssid=$bssid"
	fi

	if [ -z "$sta_pri" ]; then
		echo "	priority=1"
	else
		echo "	priority=$sta_pri"
	fi

	if [ "$sta_enc" == "psk2+ccmp" ]; then
		echo "	key_mgmt=SAE WPA-PSK WPA-PSK-SHA256"
		echo "	proto=RSN"
		echo "	beacon_prot=0"
		echo "	psk=$sta_key"
		echo "	sae_password=$sta_key"
		echo "	pairwise=CCMP"
		echo "	group=CCMP"
		echo "	ieee80211w=1"
		echo "}"
	elif [ "$sta_enc" == "mixed-psk" ]; then
		echo "	key_mgmt=WPA-PSK"
		echo "	proto=RSN WPA"
		echo "	psk=$sta_key"
		echo "	pairwise=CCMP"
		echo "	group=CCMP TKIP"
		echo "	ieee80211w=0"
		echo "}"
	else
		echo "	key_mgmt=NONE"
		echo "	ieee80211w=0"
		echo "}"
	fi
}

if [ "$vif" == "sta0" ]; then
	vif_dis=$(uci -q get wireless.$vif.disabled)

	if [ "$vif_dis" == "0" ]; then
		set_wpa_param sta02
		set_wpa_param sta03
		set_wpa_param sta04
	fi
elif [ "$vif" == "sta1" ]; then
	vif_dis=$(uci -q get wireless.$vif.disabled)

	if [ "$vif_dis" == "0" ]; then
		set_wpa_param sta12
		set_wpa_param sta13
		set_wpa_param sta14
	fi
elif [ "$vif" == "sta2" ]; then
	vif_dis=$(uci -q get wireless.$vif.disabled)

	if [ "$vif_dis" == "0" ]; then
		set_wpa_param sta22
		set_wpa_param sta23
		set_wpa_param sta24
	fi
elif [ "$vif" == "sta3" ]; then
	vif_dis=$(uci -q get wireless.$vif.disabled)

	if [ "$vif_dis" == "0" ]; then
		set_wpa_param sta32
		set_wpa_param sta33
		set_wpa_param sta34
	fi
fi
